#!/bin/bash
#
# Conversor de fitxers PDF a format HTML5
#
# Autor: Joan de Gracia
# Àrea de Cultura Digital - Departament d'Educació
# Llicència GPL 3
# Data: 24/03/2020
# Versió: 1.0
#
PDFTOPPM=$(which pdftoppm)
CONVERT=$(which convert)
ZENITY=$(which zenity)
ZIP=$(which zip)
XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
TEMPLATES=/usr/share/linkat-pdf2html5/templates.tar.gz
DIR_TEMP=$(mktemp -d)
PREFIX="large"
FITXER="$($ZENITY --file-selection --file-filter=*.pdf --title="Seleccioneu un fitxer pdf")"
if [ -z "$FITXER" ]; then
   $ZENITY --width=300 --info --text "Heu de seleccionar un fitxer. Torneu a executar el programa."
   exit 0
fi

XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
ZIP=$(which zip)
SUFIX="large"
SUFIX_THUMB="thumb"
EXTENSION="jpg"
NOM_LLIBRE=$($ZENITY --width=300 --entry \
--title="Títol de la unitat" \
--text="Entreu el nom:" \
--entry-text "PER CANVIAR" )
NOM_TEMP=$(echo "$NOM_LLIBRE" | tr " " _)
#NOM_TEMP=$(echo "$NOM_LLIBRE" | tr " " _ | tr -dc '\0-\177')

mv $DIR_TEMP /tmp/$NOM_TEMP
DIR_TEMP=/tmp/$NOM_TEMP
BOOK="$DIR_TEMP"/book
PAGES="$DIR_TEMP"/book/pages
#
# ES COPIA L'ORIGINAL PER NO PERDRE'L I PODER GENERAR ELS LLIBRES HTML5 QUE CALGUIN
# A PARTIR DE L'ORIGINAL
cp "$FITXER" $DIR_TEMP
#
tar -zxf $TEMPLATES --directory=$DIR_TEMP
cd $PAGES
$ZENITY --width=300 --info --text "Premeu el botó <b>D\'acord</b> per convertir el pdf"
COUNTER=0
#
# RESOLUTION_PDF_CONVERTED=300 - Controla la resolució quan es fa el canvi de PDF a imatge
#
RESOLUTION_PDF_CONVERTED=$($ZENITY --width=300 --entry \
--title="Resolució del PDF convertit" \
--text="Valor:" \
--entry-text "300" )
if [ "$RESOLUTION_PDF_CONVERTED" == "" ]; then
   RESOLUTION_PDF_CONVERTED=300
fi
RESOLUTION=$RESOLUTION_PDF_CONVERTED
RESOLUTION_THUMB=100
($PDFTOPPM -r $RESOLUTION_PDF_CONVERTED -jpeg "$FITXER" convert

   for i in $(ls $PAGES); do
      COUNTER=$((COUNTER+1))
      mv $i $COUNTER.$EXTENSION
      $CONVERT $COUNTER.$EXTENSION -resize $RESOLUTION_THUMB $COUNTER-$SUFIX_THUMB.$EXTENSION
   done
) |
$ZENITY --width=300 --progress \
   title="Procés de la conversió PDF a HTML" \
   text="Convertint..." \
   --auto-close --pulsate
N_PAGES=$(ls $PAGES |grep -i thumb | wc -l)
sed -i "s/_CADENA_PER_CANVIAR_/$NOM_LLIBRE/g" $BOOK/plantilla_index_top.html
sed -i "s/_N_PAGES_/$N_PAGES/g" $BOOK/plantilla_index_bottom.html
cd $BOOK
cat plantilla_index_top.html  plantilla_index_bottom.html > index.html
rm plantilla_index_top.html  plantilla_index_bottom.html
cd $DIR_TEMP
cd /tmp
$ZIP -r "$NOM_TEMP".zip "$NOM_TEMP"
mv "$NOM_TEMP".zip $ESCRIPTORI/.
#
# NETEJA EL DIRECTOR TEMPORAL
#
rm -rf $DIR_TEMP
$ZENITY --width=300 --info --text "Conversió realitzada. \n\n Trobareu el fitxer a l\'escriptori."
